import org.eclipse.swt.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.events.*;

public class AdvancedWidgetsDemo {
	
	public static Display display;

	public static void main(String[] args) {
		AdvancedWidgetsDemo awd = new AdvancedWidgetsDemo();
		awd.runDemo();
	}

	public void runDemo() {
		display = new Display();
		Shell shell = new Shell(display);
		shell.setSize(450,400);
		shell.setText("Advanced Widgets Demo");
		
		Label label1 = new Label(shell, SWT.NULL);
		label1.setText("Advanced Widgets Demo");
		label1.setLocation(120,10);
		label1.setSize(180,30);

		Button button1 = new Button(shell,SWT.PUSH);
		button1.setText("Color Font Demo");
		button1.setLocation(10,50);
		button1.setSize(140,30);
		button1.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				ColorFontDemo cfd = new ColorFontDemo();
				cfd.runDemo(display);
			}
		});


		Button button2 = new Button(shell,SWT.PUSH);
		button2.setText("Cool Bar Demo");
		button2.setLocation(150,50);
		button2.setSize(140,30);
		button2.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				CoolBarDemo cbd = new CoolBarDemo();
				cbd.runDemo(display);
			}
		});

		Button button3 = new Button(shell,SWT.PUSH);
		button3.setText("GC Demo");
		button3.setLocation(290,50);
		button3.setSize(140,30);
		button3.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				GCDemo gcd = new GCDemo();
				gcd.runDemo(display);
			}
		});

		Button button4 = new Button(shell,SWT.PUSH);
		button4.setText("GC Demo 2");
		button4.setLocation(10,100);
		button4.setSize(140,30);
		button4.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				GCDemo2 gcd2 = new GCDemo2();
				gcd2.runDemo(display);
			}
		});

		Button button5 = new Button(shell,SWT.PUSH);
		button5.setText("Image Button Demo");
		button5.setLocation(150,100);
		button5.setSize(140,30);
		button5.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				ImageButtonDemo ibd = new ImageButtonDemo();
				ibd.runDemo(display);
			}
		});

		Button button6 = new Button(shell,SWT.PUSH);
		button6.setText("Image Demo");
		button6.setLocation(290,100);
		button6.setSize(140,30);
		button6.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				ImageDemo id = new ImageDemo();
				id.runDemo(display);
			}
		});

		Button button7 = new Button(shell,SWT.PUSH);
		button7.setText("Image Menu Demo");
		button7.setLocation(10,150);
		button7.setSize(140,30);
		button7.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				ImageMenuDemo imd = new ImageMenuDemo();
				imd.runDemo(display);
			}
		});

		Button button8 = new Button(shell,SWT.PUSH);
		button8.setText("Menu Demo");
		button8.setLocation(150,150);
		button8.setSize(140,30);
		button8.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				MenuDemo md = new MenuDemo();
				md.runDemo(display);
			}
		});

		Button button9 = new Button(shell,SWT.PUSH);
		button9.setText("Offscreen Image");
		button9.setLocation(290,150);
		button9.setSize(140,30);
		button9.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				OffscreenImageDemo oid = new OffscreenImageDemo();
				oid.runDemo(display);
			}
		});

		Button button10 = new Button(shell,SWT.PUSH);
		button10.setText("Popup Menu Demo");
		button10.setLocation(10,200);
		button10.setSize(140,30);
		button10.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				PopupMenuDemo pmd = new PopupMenuDemo();
				pmd.runDemo(display);
			}
		});

		Button button11 = new Button(shell,SWT.PUSH);
		button11.setText("Progress Bar Demo");
		button11.setLocation(150,200);
		button11.setSize(140,30);
		button11.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				ProgressBarDemo pbd = new ProgressBarDemo();
				pbd.runDemo(display);
			}
		});

		Button button12 = new Button(shell,SWT.PUSH);
		button12.setText("Simple Menu Demo");
		button12.setLocation(290,200);
		button12.setSize(140,30);
		button12.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				SimpleMenuDemo smd = new SimpleMenuDemo();
				smd.runDemo(display);
			}
		});

		Button button13 = new Button(shell,SWT.PUSH);
		button13.setText("Slider Scale Demo");
		button13.setLocation(10,250);
		button13.setSize(140,30);
		button13.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				SliderScaleDemo ssd = new SliderScaleDemo();
				ssd.runDemo(display);
			}
		});

		Button button14 = new Button(shell,SWT.PUSH);
		button14.setText("Splash Demo");
		button14.setLocation(150,250);
		button14.setSize(140,30);
		button14.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				SplashDemo sd = new SplashDemo();
				sd.runDemo(display);
			}
		});

		Button button15 = new Button(shell,SWT.PUSH);
		button15.setText("Tab Demo");
		button15.setLocation(290,250);
		button15.setSize(140,30);
		button15.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				TabDemo td = new TabDemo();
				td.runDemo(display);
			}
		});

		Button button16 = new Button(shell,SWT.PUSH);
		button16.setText("Table Demo");
		button16.setLocation(10,300);
		button16.setSize(140,30);
		button16.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				TableDemo tabd = new TableDemo();
				tabd.runDemo(display);
			}
		});

		Button button17 = new Button(shell,SWT.PUSH);
		button17.setText("Tool Bar Demo");
		button17.setLocation(150,300);
		button17.setSize(140,30);
		button17.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				ToolBarDemo tbd = new ToolBarDemo();
				tbd.runDemo(display);
			}
		});

		Button button18 = new Button(shell,SWT.PUSH);
		button18.setText("Tree Demo");
		button18.setLocation(290,300);
		button18.setSize(140,30);
		button18.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				TreeDemo tred = new TreeDemo();
				tred.runDemo(display);
			}
		});

		shell.open();

		while(!shell.isDisposed()){
		if(!display.readAndDispatch())
			display.sleep();
		}
		display.dispose();
	}
}

