import org.eclipse.swt.*;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.layout.*;

public class ControlTest
{
	// Hauptfenster
	Shell Fenster;
	
	// Kontrollelemente
	Button Knopf;
	Canvas Leinwand;
	Button Kreuzel;
	Combo  Auswahl;
	Label   Beschriftung;
	List Liste;
	Slider Rollbalken;
	Text TextFeld;
	Text TextBereich;

	public static void main(String[] args)
	{
		Display display = new Display();
		ControlTest derTest = new ControlTest();
		while(display.getShells().length != 0)
			// Ereignisse auswerten und weiterleiten
			if(!display.readAndDispatch())
				// Wenn keine Ereignisse mehr vorhanden
				// in Ruhemodus wechseln
				display.sleep();
	}

	public ControlTest()
	{
		//Fenster ohne Elternfenster erzeugen
		this((Shell)null);
	}
	
	public ControlTest(Shell Elternfenster)
	{
		// Aktuelle Instanz von Display ermitteln
		// Stellt Schnittstelle zum darunter liegenden Betriebssystem dar  
		Display display = Display.getCurrent();
		if(display==null) display = new Display();
		
		// Hauptfenster erzeugen
		// WICHTIG: Klasse Shell nicht zum Erweitern gedacht
		if(Elternfenster==null)
			Fenster = new Shell(display,SWT.DIALOG_TRIM);
		else
			Fenster = new Shell(Elternfenster,SWT.DIALOG_TRIM);

		// Setzen der berschrift des Hauptfensters
		Fenster.setText("Hauptfenster mit verschiedenen Steuerelementen");

		// Einstellen der Position und Gre des Hauptfensters
		Fenster.setBounds(0,0,450,280);
		
		// Hintergrundfarbe des Haupfensters einstellen
		Fenster.setBackground(display.getSystemColor(SWT.COLOR_WHITE));
		
		// Knopf erzeugen
		Knopf = new	 Button(Fenster,SWT.PUSH);
		Knopf.setText("eine Schaltlche");
		// Mit pack() auf bevorzugte Gre einstellen
		Knopf.pack();
		Knopf.setLocation(20,25);
		
		// Zeichenflche erzeugen, Hintergrundfarbe und Gre einstellen
		Leinwand = new  Canvas(Fenster,SWT.NONE);
		Leinwand.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_CYAN));
		Leinwand.setBounds(145,10,50,50);
		
		// Markierungsfeld erzeugen
		Kreuzel = new Button(Fenster, SWT.CHECK);
		Kreuzel.setText("Hier ankreuzen!");
		Kreuzel.setBackground(display.getSystemColor(SWT.COLOR_WHITE));
		Kreuzel.pack();
		Kreuzel.setLocation(205,28);
		
		// Auswahlliste erzeugen und drei Eintrge hinzufgen
		Auswahl = new Combo(Fenster,SWT.READ_ONLY);
		Auswahl.add("erster Eintrag");
		Auswahl.add("zweiter Eintrag");
		Auswahl.add("dritter Eintrag");
		Auswahl.select(0);
		Auswahl.pack();
		Auswahl.setLocation(310,25);
		
		// Textzeile erzeugen
		Beschriftung = new Label(Fenster,SWT.NONE);
		Beschriftung.setFont(new Font(display,"Arial",10,SWT.NONE));
		Beschriftung.setBackground(display.getSystemColor(SWT.COLOR_WHITE));
		Beschriftung.setText("Hier ist die Beschriftung");
		Beschriftung.pack();
		Beschriftung.setLocation(50,90);
		
		// Kombinationsfeld erzeugen und fnf Eintrge hinzufgen
		Liste = new List(Fenster,SWT.SINGLE|SWT.BORDER|SWT.V_SCROLL);
		Liste.add("erster Eintrag");
		Liste.add("zweiter Eintrag");
		Liste.add("dritter Eintrag");
		Liste.add("vierter Eintrag");
		Liste.add("fnfter Eintrag");
		Liste.setLocation(210,70);
		Liste.setSize(120,60);
		
		// Horizontalen Rollbalken erzeugen
		Rollbalken = new Slider(Fenster,SWT.HORIZONTAL);
		Rollbalken.setBounds(335,90,50,15);
		
		// Einzeiliges Eingabefeld erzeugen
		TextFeld = new Text(Fenster,SWT.SINGLE|SWT.BORDER);
		TextFeld.setText("Eintrag im Textfeld");
		TextFeld.setTextLimit(20);
		//TextFeld.pack();
		TextFeld.setBounds(20,180,160,TextFeld.getLineHeight()+7);
		
		// Mehrzeiliges Eingabefeld erzeugen
		TextBereich = new Text(Fenster,SWT.MULTI|SWT.BORDER|SWT.V_SCROLL|SWT.H_SCROLL);
		TextBereich.setText("Eintrag im Textbereich");
		TextBereich.setBounds(190,140,220,(TextBereich.getLineHeight()+5)*5);

		// Hauptfenster anzeigen
		Fenster.open();
	}
}
