import org.eclipse.swt.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;

public class SteuerFenster extends ShellAdapter implements SelectionListener
{
	// Schaltflchen zur Steuerung (als Array angelegt)
	Button[] dieKnoepfe = new Button[8];

	// das zu steuernde Fenster als Attribut von SteuerFenster
	ControlTest einTestFenster;
	Shell dasSteuerFenster;

	public static void main(String[] args)
	{
		Display display = new Display();
		new SteuerFenster();
		while(display.getShells().length != 0)
			// Ereignisse auswerten und weiterleiten
			if(!display.readAndDispatch())
				// wenn keine Ereignisse mehr vorhanden
				// in Ruhemodus wechseln
				display.sleep();
	}

	public SteuerFenster()
	{
		// Erzeugen des Hauptfensters und Zuordnung des LayoutManagers
		dasSteuerFenster = new Shell();
		dasSteuerFenster.setText("Steuerung");
		GridLayout layout = new GridLayout(4,true);
		layout.horizontalSpacing = 0;
		layout.verticalSpacing = 0;
		dasSteuerFenster.setLayout(layout);
		dasSteuerFenster.setBounds(0,150,400,200);
		dasSteuerFenster.addShellListener(this);

		// Erzeugen der Steuerschaltflchen und Zuordnung des SelectionListeners
		for(int i = 0; i < dieKnoepfe.length; i++)
		{
			dieKnoepfe[i] = new Button(dasSteuerFenster,SWT.PUSH);
			dieKnoepfe[i].addSelectionListener(this);
			dieKnoepfe[i].setLayoutData(new GridData(GridData.FILL_BOTH));		
		}
		
		dieKnoepfe[0].setText("Knopf"); 				
		dieKnoepfe[1].setText("Leinwand");		
		dieKnoepfe[2].setText("Kreuzel");				
		dieKnoepfe[3].setText("Auswahl");			
		dieKnoepfe[4].setText("Beschriftung");	
		dieKnoepfe[5].setText("Liste");					
		dieKnoepfe[6].setText("TextFeld");			
		dieKnoepfe[7].setText("TextBereich");

        // Anzeigen des Steuerfensters
		dasSteuerFenster.open();

		// ein Fenster mit den verschiednen Kontrollelementen wird erzeugt
		einTestFenster = new ControlTest();
	}

	// Implementierung der widgetSelected-Methode aus der
	// Schnittstelle SelectionListener
	public void widgetSelected(SelectionEvent e)
	{
		// Wenn das Testfenster bereits geschlossen wurde
		// ist der Zugriff darauf nicht mehr mglich
		if(einTestFenster.Fenster.isDisposed())
			return;
		if(e.getSource() == dieKnoepfe[0]){
			einTestFenster.Knopf.setText("neuesLabel fr Knopf");
		 	einTestFenster.Knopf.pack();}
		if(e.getSource() == dieKnoepfe[1]){
			einTestFenster.Leinwand.setBackground(
			Display.getCurrent().getSystemColor(SWT.COLOR_MAGENTA));}
		if(e.getSource() == dieKnoepfe[2])
		{einTestFenster.Kreuzel.setSelection(false);}
		if(e.getSource() == dieKnoepfe[3])
		{einTestFenster.Beschriftung.setText("neue Beschriftung");}
		if(e.getSource() == dieKnoepfe[4])
		{einTestFenster.Auswahl.add("neuer Eintrag", 0);}
		if(e.getSource() == dieKnoepfe[5])
		{einTestFenster.Liste.add("neuer Eintrag", 0);}
		if(e.getSource() == dieKnoepfe[6])
		{einTestFenster.TextFeld.setText("neuer Text");}
		if(e.getSource() == dieKnoepfe[7])
		{einTestFenster.TextBereich.setText("neuer Text");}
	}
	
	public void widgetDefaultSelected(SelectionEvent e)
	{
	}
	
	// berschreiben der shellClosed-Methode
	// Schliet das Testfenster, wenn das Steuerfenster geschlossen wird
	public void shellClosed(ShellEvent e)
	{
		if(!einTestFenster.Fenster.isDisposed())
			einTestFenster.Fenster.dispose();
	} 
}

