import org.eclipse.swt.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.dnd.*;

class MenueClipBoard extends SelectionAdapter
{
	// Textfeld fr den Test der Zwischenablage und der Mens
	Text dieTextFlaeche;

	// Instanz der Zwischenablage
	Clipboard dieZwischenablage;

	// Hauptmens und Meneintrge
	Menu mLeiste, mDatei, mHilfe, mBearbeiten;
	MenuItem miDatei, miBeenden, miHilfe, miHilfeE, 
			 miBearbeiten, miKopieren, miAusschneiden, miEinfuegen;

	public static void main(String[] args)
	{
		Display display = new Display();
		new MenueClipBoard();
		// Schleife wird solange durchlaufen, wie noch 
		// nicht geschlossene Fenster vorhanden sind		
		while(display.getShells().length != 0)
			if(!display.readAndDispatch())
				display.sleep();
	}

	public MenueClipBoard()
	{
		// Anlegen des Fensters
		Display display = Display.getCurrent();
		if(display == null)
			display = new Display();
		Shell dasFenster = new Shell(display);
		dasFenster.setSize(400, 250);

		// Fenstertitel an Shell bergeben
		dasFenster.setText("Mens, Tastaturkrzel und Zwischenablage");

		// Zuweisung eines Layouts
		dasFenster.setLayout(new FillLayout(SWT.VERTICAL));

		dieZwischenablage = new Clipboard(display);

		// Erzeugen der Menleiste
		mLeiste = new Menu(dasFenster, SWT.BAR);

		// Erzeugen der Mens und ihrer Eintrge
		// Jeder Meneintrag wird einem Men, jedes Men der 
		// Menleiste hizugefgt.
		//
		// Jeder Menueintrag bekommt ein Tastaturkrzel zu gewiesen,
		// d. h. es fngt einen bestimmten KeyEvent ab. Dabei
		// ist systembhngig voreingestellt, welche Sondertaste
		// zustzlich gedrckt sein muss
		// (z.B. Windows: Control-/Steuertaste)
		miDatei = new MenuItem(mLeiste, SWT.CASCADE);
		miDatei.setText("Datei");
		mDatei = new Menu(dasFenster, SWT.DROP_DOWN);
		miDatei.setMenu(mDatei);
		
		miBeenden = new MenuItem(mDatei, SWT.PUSH);
		miBeenden.setText("Beenden\tStrg+F1");
		miBeenden.setAccelerator(SWT.CONTROL | SWT.F1);
		miBeenden.addSelectionListener(this);

		miHilfe = new MenuItem(mLeiste, SWT.CASCADE);
		miHilfe.setText("Hilfe");
		mHilfe = new Menu(dasFenster, SWT.DROP_DOWN);
		miHilfe.setMenu(mHilfe);
		
		miHilfeE = new MenuItem(mHilfe, SWT.PUSH);
		miHilfeE.setText("Hilfe\tStrg+H");
		miHilfeE.setAccelerator(SWT.CONTROL | 'H');
		miHilfeE.addSelectionListener(this);

		miBearbeiten = new MenuItem(mLeiste, SWT.CASCADE);
		miBearbeiten.setText("Bearbeiten");
		mBearbeiten = new Menu(dasFenster, SWT.DROP_DOWN);
		miBearbeiten.setMenu(mBearbeiten);

		miKopieren = new MenuItem(mBearbeiten, SWT.PUSH);
		miKopieren.setText("Kopieren\tStrg+C");
		miKopieren.setAccelerator(SWT.CONTROL | 'C');
		miKopieren.addSelectionListener(this);
		
		miAusschneiden = new MenuItem(mBearbeiten, SWT.PUSH);
		miAusschneiden.setText("Ausschneiden\tStrg+X");
		miAusschneiden.setAccelerator(SWT.CONTROL | 'X');
		miAusschneiden.addSelectionListener(this);
		
		miEinfuegen = new MenuItem(mBearbeiten, SWT.PUSH);
		miEinfuegen.setText("Einfuegen\tStrg+V");
		miEinfuegen.setAccelerator(SWT.CONTROL | 'V');
		miEinfuegen.addSelectionListener(this);
		
		dasFenster.setMenuBar(mLeiste);


		String StartText = 	
					"Dies ist der Starttext.\n\nDas Programm lsst sich " +
					"ber die Mens oder ber Tastaturkrzel bedienen,\n" +
					"z. B. Kopieren: Ctrl/Strg + C";



		dieTextFlaeche = new Text(dasFenster, SWT.BORDER|SWT.WRAP);
		dieTextFlaeche.setText(StartText);
		dasFenster.open();
	}
	
	// Implementierung der in der Schnittstelle
	// ActionListener enthaltenen Methode actionPerformed()
	public void widgetSelected(SelectionEvent e)
	{
		if(e.widget == miBeenden)
		{
			System.out.println("Anwendung beendet (System.exit(0)).");
			System.exit(0);
		}
		if(e.widget == miHilfeE)
		{
			dieTextFlaeche.setText(
				"Dieser Text simuliert die Reaktion der Hilfe ...");
		}

		if(e.widget == miKopieren)
		{
			String derText = dieTextFlaeche.getSelectionText();
 
			dieZwischenablage.setContents(new Object[]{derText},
								// TextTransfer ist ein Singleton Muster 
								// Transfer beschreibt den Typ der Daten 
								new Transfer[]{TextTransfer.getInstance()});
		}
		if(e.widget == miAusschneiden)
		{
			String derText = dieTextFlaeche.getSelectionText();
			dieTextFlaeche.cut();
 			dieZwischenablage.setContents(new Object[]{derText},
								new Transfer[]{TextTransfer.getInstance()});
		}
		if(e.widget == miEinfuegen)
		{
			String derText = (String)dieZwischenablage.getContents(TextTransfer.getInstance());
			if(derText != null)
				dieTextFlaeche.insert(derText);
		}
	}

}